global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca v comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA


function dy = CGC_CaHVA (y, t)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca v comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  v  =  y(1);
  % rate eq CaHVA_hO
  CaHVA_hO  =  y(2);
  % rate eq CaHVA_mO
  CaHVA_mO  =  y(3);
  % equation for CaHVA_m
  CaHVA_m  =  CaHVA_mO;
  % equation for CaHVA_h
  CaHVA_h  =  CaHVA_hO;
  dy  =  zeros(length(y), 1);
  % state CaHVA_hO
  v452  =  CaHVA_hO;; 
dy(2)  =  -(CaHVA_hO * comp33_beta_u(v)) + (1 - v452) * (comp33_alpha_u(v));
  % state CaHVA_mO
  v455  =  CaHVA_mO;; 
dy(3)  =  -(CaHVA_mO * comp33_beta_s(v)) + (1 - v455) * (comp33_alpha_s(v));
  v449  =  CaHVA_m;; 
i_CaHVA  =  (comp33_gbar * v449 * v449 * CaHVA_h) * (v - comp33_e);
  ica  =  i_CaHVA;
  dy(1)  =  0.0;


end


function y0 = CGC_CaHVA_init (Vinit)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca v comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  y0  =  zeros(3, 1);
  v  =  Vinit;
  y0(1)  =  v;
  comp33_V0alpha_s  =  -29.06;
  comp307_vcinc  =  10.0;
  comp307_vchdur  =  30.0;
  fix_celsius  =  30.0;
  comp33_gbar  =  0.00046;
  comp33_Kalpha_s  =  15.87301587302;
  comp33_Kalpha_u  =  -18.183;
  comp307_vcbase  =  -69.0;
  comp33_V0beta_s  =  -18.66;
  comp307_vcbdur  =  100.0;
  comp307_vchold  =  -71.0;
  comp33_Q10  =  3.0;
  comp33_e  =  129.33;
  comp33_V0alpha_u  =  -48.0;
  comp33_Kbeta_u  =  83.33;
  comp33_Aalpha_s  =  0.04944;
  comp33_Kbeta_s  =  -25.641;
  comp33_Aalpha_u  =  0.0013;
  comp33_V0beta_u  =  -48.0;
  comp307_vcsteps  =  8.0;
  comp33_Abeta_s  =  0.08298;
  comp33_Abeta_u  =  0.0013;
  CaHVA_h  =  (comp33_alpha_u(v)) / (comp33_alpha_u(v) + comp33_beta_u(v));
  CaHVA_hO  =  CaHVA_h;
  CaHVA_m  =  (comp33_alpha_s(v)) / (comp33_alpha_s(v) + comp33_beta_s(v));
  CaHVA_mO  =  CaHVA_m;
  y0(2)  =  CaHVA_hO;
  y0(3)  =  CaHVA_mO;
  v449  =  CaHVA_m;; 
i_CaHVA  =  (comp33_gbar * v449 * v449 * CaHVA_h) * (v - comp33_e);
  ica  =  i_CaHVA;


end




function retval456 = comp33_alpha_u (v)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  retval456  =  comp33_Q10 * comp33_Aalpha_u * exp((v + -(comp33_V0alpha_u)) / comp33_Kalpha_u);
end




function retval457 = comp33_alpha_s (v)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  retval457  =  comp33_Q10 * comp33_Aalpha_s * exp((v + -(comp33_V0alpha_s)) / comp33_Kalpha_s);
end




function retval458 = comp33_beta_u (v)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  retval458  =  comp33_Q10 * comp33_Abeta_u * exp((v + -(comp33_V0beta_u)) / comp33_Kbeta_u);
end




function retval459 = comp33_beta_s (v)
  global CaHVA_h CaHVA_m comp307_vcbdur comp307_vchdur comp307_vcsteps comp307_vcinc comp307_vcbase comp307_vchold comp33_e comp33_gbar ica eca comp33_V0alpha_s comp307_vcinc comp307_vchdur fix_celsius comp33_gbar comp33_Kalpha_s comp33_Kalpha_u comp307_vcbase comp33_V0beta_s comp307_vcbdur comp307_vchold comp33_Q10 comp33_e comp33_V0alpha_u comp33_Kbeta_u comp33_Aalpha_s comp33_Kbeta_s comp33_Aalpha_u comp33_V0beta_u comp307_vcsteps comp33_Abeta_s comp33_Abeta_u i_CaHVA
  retval459  =  comp33_Q10 * comp33_Abeta_s * exp((v + -(comp33_V0beta_s)) / comp33_Kbeta_s);
end


